import cv2
import numpy as np
import math

# Load an image
oranges = cv2.imread('oranges.jpg')
cv2.imshow('Original', oranges)

# # Thresholding in RGB
# # Sampled RGB values:
# # 83, 38, 6
# # 200, 125, 2
LOWER = np.array([0, 28, 70])
UPPER = np.array([15, 135, 220])
rgb_mask = cv2.inRange(oranges, LOWER, UPPER)
cv2.imshow('RGB Mask', rgb_mask)

#
# # Thresholding in HSV
LOWER = np.array([0, 200, 70])
UPPER = np.array([30, 255, 255])
oranges_hsv = cv2.cvtColor(oranges, cv2.COLOR_BGR2HSV)
hsv_mask = cv2.inRange(oranges_hsv, LOWER, UPPER)
cv2.imshow('HSV Mask', hsv_mask)


# Combine mask and the original image
mask_3 = cv2.cvtColor(hsv_mask, cv2.COLOR_GRAY2BGR)
oranges_only = cv2.bitwise_and(mask_3, oranges)
cv2.imshow('Oranges Only', oranges_only)

cv2.waitKey(0)

def rgb2hsv(r, g, b):
    rgbPixel = np.array([[[r, g, b]]], dtype=np.uint8)
    hsvPixel = cv2.cvtColor(rgbPixel, cv2.COLOR_RGB2HSV)
    return hsvPixel[0][0]
