import cv2
import numpy as np

def drawLines(img, lines):
    # Draw lines on an image
    for line in lines:
        rho, theta = line[0]
        a = np.cos(theta)
        b = np.sin(theta)
        x0 = a * rho
        y0 = b * rho
        x1 = int(x0 + 2000 * (-b))
        y1 = int(y0 + 2000 * (a))
        x2 = int(x0 - 2000 * (-b))
        y2 = int(y0 - 2000 * (a))
        cv2.line(img, (x1, y1), (x2, y2), (0, 0, 255), 2)


# Load image and show original
highway = cv2.imread('highway.jpg')
cv2.imshow('Original', highway)

# Blur
blurred = cv2.GaussianBlur(highway, (5, 5), 4)
cv2.imshow('Blurred', blurred)

# Canny edge detection
edges = cv2.Canny(blurred, 100, 200)
cv2.imshow('Edges', edges)

# Blur edges
edges_blurred = cv2.GaussianBlur(edges, (5, 5), 1)
cv2.imshow('Edges blurred', edges_blurred)

# Hough transform
lines = cv2.HoughLines(edges_blurred, 1, np.pi/180, 300)
drawLines(highway, lines)
cv2.imshow('lines', highway)

cv2.waitKey(0)
